function res = log_vrais_parametrique(vect_parametres, nb_param_theta, ...
            theta0, y0, delta1, delta2, vect_unif, data, indic_Ftheta, indic_Cprime, indic_vect)

if nargin < 11
    indic_vect = 0;
end
        
n = size(data,1);           
n_s = size(vect_unif,2);

param_theta = exp(vect_parametres(1:nb_param_theta)); 
param_Cprime = exp(vect_parametres(nb_param_theta+1:end)); 

% Pour la log-normale on n'impose pas la positivit du paramtre de
% translation
if indic_Ftheta == 2 
    for k=1:nb_param_theta-1
        param_theta(k) = vect_parametres(k);
    end
end

 
% Interviewers there in (2001 or 2002) and 2003
stayers = data((data(:,2)>0 & data(:,4)>0),:);

t1_st = stayers(:,1) * ones(1,n_s);
n1_st = stayers(:,2) * ones(1,n_s);
t2_st = stayers(:,3) * ones(1,n_s);
n2_st = stayers(:,4) * ones(1,n_s);

n_st = size(n1_st,1);

vect_theta_st = inv_Ftheta([param_theta(1);param_theta(nb_param_theta)], vect_unif, indic_Ftheta);

y1_st = ones(n_st,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta1./vect_theta_st, indic_Cprime) ;
y2_st = ones(n_st,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta2./vect_theta_st, indic_Cprime) ;

logvrais_st = log(mean((y1_st.^t1_st) .* ((1-y1_st).^(n1_st-t1_st)) .* (y2_st.^t2_st) ...
		.* ((1-y2_st).^(n2_st-t2_st)),2)) ;

if indic_vect == 1
    res = - logvrais_st;
else
    res = - mean(logvrais_st);
end

% Interviewers who participate either in (2001-2002) or in 2003
movers = data((data(:,2)==0 | data(:,4)==0),:);

if nb_param_theta > 2
    if nb_param_theta == 3
        t1_mov = movers(:,1) * ones(1,n_s);
        n1_mov = movers(:,2) * ones(1,n_s);
        t2_mov = movers(:,3) * ones(1,n_s);
        n2_mov = movers(:,4) * ones(1,n_s);

        n_mov = size(n1_mov,1);

        vect_theta_mov = inv_Ftheta(param_theta(2:3), vect_unif, indic_Ftheta);

        y1_mov = ones(n_mov,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta1./vect_theta_mov, indic_Cprime) ;
        y2_mov = ones(n_mov,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta2./vect_theta_mov, indic_Cprime) ;

        logvrais_mov = log(mean((y1_mov.^t1_mov) .* ((1-y1_mov).^(n1_mov-t1_mov)) .* (y2_mov.^t2_mov) ...
            .* ((1-y2_mov).^(n2_mov-t2_mov)),2)) ;
    else
    
        t1_mov = movers((movers(:,2)>0),1) * ones(1,n_s);
        n1_mov = movers((movers(:,2)>0),2) * ones(1,n_s);
        t2_mov = movers((movers(:,4)>0),3) * ones(1,n_s);
        n2_mov = movers((movers(:,4)>0),4) * ones(1,n_s);

        n_mov1 = size(n1_mov,1);
        n_mov2 = size(n2_mov,1);

        vect_theta_mov1 = inv_Ftheta([param_theta(2);param_theta(4)], vect_unif, indic_Ftheta);
        vect_theta_mov2 = inv_Ftheta([param_theta(3);param_theta(4)], vect_unif, indic_Ftheta);

        y1_mov = ones(n_mov1,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta1./vect_theta_mov1, indic_Cprime) ;
        y2_mov = ones(n_mov2,1) * inv_Cprime(param_Cprime, theta0, y0, delta1, delta2./vect_theta_mov2, indic_Cprime) ;

        logvrais_mov1 = log(mean((y1_mov.^t1_mov) .* ((1-y1_mov).^(n1_mov-t1_mov)),2));
        logvrais_mov2 = log(mean((y2_mov.^t2_mov) .* ((1-y2_mov).^(n2_mov-t2_mov)),2));
        logvrais_mov = [logvrais_mov1;logvrais_mov2];
    end
   
if indic_vect == 1
    res = - [logvrais_st;logvrais_mov];
else
    res = -(sum(logvrais_st)+sum(logvrais_mov))/n;
end
end