function res = log_vrais_parametrique_X(vect_parametres, theta0, y0, delta1, ...
                delta2, vect_unif, data, indic_Cprime)

n = size(data,1);           
n_s = size(vect_unif,2);

nb_x= (size(data,2)-4)/2;

X1 = data(:,5:nb_x+4);
X2 = data(:,nb_x+5:end);

a0 = vect_parametres(1);
aX = vect_parametres(2:nb_x+1);
sigma = exp(vect_parametres(end-1));
beta=exp(vect_parametres(end));

% Eliminate missing data
missing1 = max(isnan(X1),[],2);
missing2 = max(isnan(X2),[],2);


t1 = repmat(data(:,1).*(1-missing1),1,n_s);
n1 = repmat(data(:,2).*(1-missing1),1,n_s);
t2 = repmat(data(:,3).*(1-missing2),1,n_s);
n2 = repmat(data(:,4).*(1-missing2),1,n_s);

X1(missing1,:) = zeros(sum(missing1),nb_x);
X2(missing2,:) = zeros(sum(missing2),nb_x);

vect_theta1 = exp(a0 + repmat(X1 * aX,1,n_s) + sigma * repmat(norminv(vect_unif),n,1));
vect_theta2 =  exp(a0 + repmat(X2 * aX,1,n_s) + sigma * repmat(norminv(vect_unif),n,1));
y1 = inv_Cprime(beta, theta0, y0, delta1, delta1./vect_theta1, indic_Cprime) ;
y2 = inv_Cprime(beta, theta0, y0, delta1, delta2./vect_theta2, indic_Cprime) ;

logvrais = log(mean((y1.^t1) .* ((1-y1).^(n1-t1)) .* (y2.^t2) .* ((1-y2).^(n2-t2)),2)) ;

res = -sum(logvrais)/n;