%% Construction of the data

clear, clc
load matlab_data ;
data = double(st_dataset);
rng(1);

data1 = data(data(:,2)>0 & data(:,2)<35,1:2);
data2 = data(data(:,4)>0 & data(:,4)<35,3:4);

r1=data1(:,1);
n1=data1(:,2);
r2=data2(:,1);
n2=data2(:,2);

[tbl1,~,~,labels]=crosstab(n1,r1);
temp=str2double(labels);
vect_K1 = temp(:,1)';
% Construction of a proper database with 0 if needed
for_db1 = zeros(length(vect_K1), max(vect_K1)+1);

for j=1:max(vect_K1)+1
    if sum(temp(:,2)==j-1)>0
        for_db1(:,j) = tbl1(:,(temp(:,2)==j-1));
    end
end
    
db1 = -99*ones(length(vect_K1), max(vect_K1)+2);
i=1;
for K=vect_K1
    db1(i,1:K+1)=for_db1(i,1:K+1);
    i=i+1;
end

[tbl2,~,~,labels]=crosstab(n2,r2);
temp=str2double(labels);
vect_K2 = temp(:,1)';
% Construction of a proper database with 0 if needed
for_db2 = zeros(length(vect_K2), max(vect_K2)+1);

for j=1:max(vect_K2)+1
    if sum(temp(:,2)==j-1)>0
        for_db2(:,j) = tbl2(:,(temp(:,2)==j-1));
    end
end
    
db2 = -99*ones(length(vect_K2), max(vect_K2)+2);
i=1;
for K=vect_K2
    db2(i,1:K+1)=for_db2(i,1:K+1);
    i=i+1;
end


%% Test
% 2001-2002 survey
xp_init= stat_test_n_indep_theta(db1, vect_K1);
pvalue1=test_n_indep_theta(db1,vect_K1,5e2,xp_init)

% 2003 survey
xp_init= stat_test_n_indep_theta(db2, vect_K2);
pvalue2=test_n_indep_theta(db2,vect_K2,5e2,xp_init)

% Avec K<=25 et 500 tirages bootstrap
% pvalue1 = 0.6718
% pvalue1 = 0.83
