yinf1 = 0.2;
ysup1 = 0.8;
yinf2 = 0.3;
ysup2 = 0.85;

grid_y = (0.01:.01:0.99)';
F1 = min((grid_y>=yinf1).*(grid_y-yinf1).^2/((ysup1-yinf1)^2),1);
F2 = min((grid_y>=yinf2).*(grid_y-yinf2).^2/((ysup2-yinf2)^2),1);

y0 = 0.5 ;
y_dr = zeros(6,1);
y_dr(1)=y0 ;

for k=1:5
    y_dr(k+1)=H_sim(y_dr(k),yinf1,ysup1,yinf2,ysup2);
end

y_ga = zeros(4,1);
y_ga(1)=y0 ;

for k=1:3
    y_ga(k+1)=H_sim(y_ga(k),yinf2,ysup2,yinf1,ysup1);
end

seq_y = [flipud(y_ga);y_dr(2:end)];
F_seq_y = min((seq_y>=yinf1).*(seq_y-yinf1).^2/((ysup1-yinf1)^2),1);
F_seq_y_bis = min((seq_y>=yinf2).*(seq_y-yinf2).^2/((ysup2-yinf2)^2),1);
F_seq_y(end) = F_seq_y_bis(end);
F_seq_y_bis(1)=F_seq_y(1);

gr = zeros(100,8);
ligne_1 = zeros(100,8);
ligne_2 = zeros(100,9);
for k=1:8
    pas = (seq_y(k+1)-seq_y(k))/99;
    gr(:,k)=(seq_y(k):pas:seq_y(k+1))';
    ligne_1(:,k) = F_seq_y(k);
    ligne_2(:,k) = (0:F_seq_y_bis(k)/99:F_seq_y_bis(k))';
end

ligne_2(:,9) = (0:F_seq_y(9)/99:F_seq_y(9))';

gr1 = reshape(gr,8e2,1);
ligne1 = reshape(ligne_1,8e2,1);

gr2 = kron(seq_y, ones(1e2,1));
ligne2 = reshape(ligne_2,9e2,1);

plot(grid_y, F1, 'k',grid_y, F2, 'k-.', gr1, ligne1, 'k--',seq_y, F_seq_y, 'ko') 

ax=gca;
ax.XTick = [0 1];
ax.YTick = [0 0.2 0.4 0.6 0.8 1];
ax.FontName='Times New Roman';
ax.FontSize=12;  

fig=gcf;
suite = [0.0642857142857164 0.0454285714285715 0.0404761904761906];

for k=1:9
    line(seq_y(k)*ones(1e2,1), ligne_2(:,k),'LineStyle','--','Color',[0.5 0.5 0.5])
    texte= strcat('y_{',num2str(k-4),'}');
    annotation(fig,'textbox',...
        [0.78*seq_y(k)+0.11, suite],...
        'String',{texte},...
        'FitBoxToText','off',...    
        'LineStyle','none','FontName','Times New Roman','FontSize',12);
end

h = legend('F_{Y|X=1,S=1}','F_{Y|X=2,S=1}','Location','northwest');
legend('boxoff');
h.FontSize=12;  
h.FontName='Times New Roman';

