function [xp1, val_stat, exit]= stat_test_n_indep_theta(db,vect_K, xp_init)

    Pstacke = zeros(sum(vect_K),1);
    ind=1;
    vect_n =[];

    for K=vect_K

        % Gere les donnees
        [val,iiii] = min(db');
        count = db( (iiii-2 == K)&(val==-99) ,:);
        count = count(count>-99);
        n=round(sum(count));
        vect_n = [vect_n;n];
        Pstacke(ind:ind + K-1) = count(2:end)'/n;
        ind = ind + K;

    end
    
    k = floor(max(vect_K)/2)+1;

    % Pour taille k
    % Contraintes sur les x : suite croissante, positive et <= 1
    % + contraites sur les p : p>0
    Ad = [ [[-1,zeros(1,k-1)];eye(k) - diag(ones(k-1,1),1)] zeros(k+1,k); zeros(k,k) (-eye(k))]; 
    bd = [[-1e-6;-2e-2 * ones(k-1,1);1]; -1e-6*ones(k,1)];
    % Contrainte sur les p : somment  1
    Adeq = [zeros(1,k) ones(1,k)];
    bdeq = 1;    

    % Support initial (rpartition uniforme des K+1 points)
    xp0 = [(1/(k+1):1/(k+1):(k)/(k+1))';ones(k,1)/k] ;
    
    options=optimset(optimset('fmincon'),'Display','off','MaxFunEvals',1e4,'MaxIter',1e4);
    [xp1,~,exit] = fmincon(@(xp) pr_stat_test_n_indep_theta(xp, vect_K, vect_n, Pstacke), xp0, Ad, bd, Adeq, bdeq,[],[],[],options);
    
    if exit <=0
        if nargin < 3
            xp0 = xp_init;
        else
            xp0 = [sort(rand(k,1));ones(k,1)/k] ;
        end
        [xp1,~,exit] = fmincon(@(xp) pr_stat_test_n_indep_theta(xp, vect_K, vect_n, Pstacke), xp0, Ad, bd, Adeq, bdeq,[],[],[],options);
    end    
    
    x = xp1(1:k);
    p = xp1(k+1:end);
    Kmax= max(vect_K);
    vandermonde =  (ones(Kmax,1) * x' ).^((1:Kmax)' * ones(1,k));
    m = vandermonde * p;
  
    val_stat=0;
    i=1;
    ind=1;
    
    for K=vect_K
        Pchap = fct_Q(K) * m(1:K);
        diff = Pstacke(ind:ind + K-1) - Pchap ;
        mat_opt = (diag(Pchap) - Pchap * Pchap')/vect_n(i);
        val_stat = val_stat + diff' * (mat_opt\diff);
        ind = ind + K;
        i = i+1;
    end    
    
end


function res = pr_stat_test_n_indep_theta(xp, vect_K, vect_n, Pstacke)
    
    k=length(xp)/2;
    x = xp(1:k);
    p = xp(k+1:end);
    Kmax= max(vect_K);
    vandermonde =  (ones(Kmax,1) * x' ).^((1:Kmax)' * ones(1,k));
    m = vandermonde * p;
  
    res=0;
    i=1;
    ind=1;
    
    for K=vect_K
        res = res + norm(Pstacke(ind:ind + K-1) - fct_Q(K) * m(1:K))^2 * vect_n(i)/K;
        ind = ind + K;
        i = i+1;
    end
    
end

