% Bootstrap test of the sieve MLE specification (polynomial on the density)
% K: (degree of the polynomial for sqrt(f)) + 1

function [T_test, p_value] = test_boot_specif_MLE(r,n,K,nb_boot)

options = optimset('Display','off','MaxFunEvals',1e6,'MaxIter',100000);

a0 = sqrt(3)*[zeros(K-2,1);1;0];
a = fmincon(@(a) log_vrais_binom(a, r, n), a0, [],[],[],[],[],[],...
            @contrainte_densite,options);
b=conv(a,a);
K_L=length(b)-1;
W = weighting_matrix_GMM_test_specif_MLE(n,r,a);
T_test =stat_test_specif_MLE(a,r,n,W);

max_n=max(n);
% mat_proba: each row corresponds to a given n, indicated in the first
% column, and then column 2+r corresponds to Pr(R<=r given N=n)
mat_proba=ones(max_n,max_n+2);
mat_proba(:,1)=(1:max_n)';
for i=1:max_n
    mat_proba(i,2) = nchoosek(i,0)*(beta((0:K_L)+1,i+1) * flipud(b));
    for j=1:i
        mat_proba(i,j+2) = mat_proba(i,j+1) + nchoosek(i,j)*...
                           (beta(j+(0:K_L)+1,i-j+1) * flipud(b));
    end
end

N=length(n);
r_b=zeros(N,1);
T=zeros(nb_boot,1);

for s=1:nb_boot
    n_b=datasample(n,N);
    for i=1:N
        vect_proba=mat_proba((mat_proba(:,1)==n_b(i)),2:n_b(i)+2);
        unif=rand(1,1);
        % We draw r under the null
        r_b(i)=sum(unif>vect_proba);
    end
    a_b = fmincon(@(a) log_vrais_binom(a, r_b, n_b), a0, [],[],[],[],[],...
                    [],@contrainte_densite,options);
    W_b = weighting_matrix_GMM_test_specif_MLE(n_b,r_b,a_b);
    T(s)=stat_test_specif_MLE(a_b,r_b,n_b,W_b);
end

p_value = mean(T>T_test);

end