% Bootstrap test of n independant of theta

function res = test_n_indep_theta(db,vect_K,B, xp_init)

[xp_sol, val_stat]= stat_test_n_indep_theta(db,vect_K, xp_init);
%val_stat

k=length(xp_sol)/2;
x = xp_sol(1:k);
p = xp_sol(k+1:end);

Kmax= max(vect_K);
vandermonde =  (ones(Kmax,1) * x' ).^((1:Kmax)' * ones(1,k));
m = vandermonde * p;

% Estimation of Pstacke, to draw bootsrtap samples under the null

Pstacke_null = zeros(sum(vect_K+1),1);

ind=1;

for K=vect_K
    Pstacke_null(ind+1:ind+K) = fct_Q(K) * m(1:K);
    Pstacke_null(ind) = 1-sum(Pstacke_null(ind+1:ind+K));
    if min(Pstacke_null(ind:ind+K))<0
        Pstacke_null(ind:ind+K)=max(Pstacke_null(ind:ind+K),0)/sum(max(Pstacke_null(ind:ind+K),0));
    end
    ind = ind + K +1;
end


% Bootstrapping. We first compute vect_n
vect_n=[];
for K=vect_K
    
    % Gere les donnees
    [val,iiii] = min(db');
    count = db( (iiii-2 == K)&(val==-99) ,:);
    count = count(count>-99);
    n=round(sum(count));
    vect_n = [vect_n;n];
end

n_tot = sum(vect_n);
prop_n = vect_n/n_tot;

vect_stat_boot = [];

for b=1:B
    vect_n_boot=mnrnd(n_tot,prop_n)';
%     if min(vect_n_boot >0)
    vect_K_boot= vect_K((vect_n_boot'>0));
    db_boot = -99*ones(length(vect_K_boot), max(vect_K_boot)+2);
    i=1;
    j=1;
    ind=1;
    for K=vect_K
        if vect_n_boot(i)>0
            db_boot(j,1:K+1) = mnrnd(vect_n_boot(i),Pstacke_null(ind:ind+K));            
            j=j+1;
        end
        ind=ind+K+1;
        i=i+1;
    end
    xp0 = xp_sol;
    if length(vect_K_boot)<length(vect_K)
        k = floor(max(vect_K_boot)/2)+1;
        xp0 = zeros(2*k,1);
        xp0(1:k-1) = xp_sol(1:k-1);
        xp0(k) = mean(xp_sol(k:end/2));
        xp0(k+1:end-1) = xp_sol(end/2+1:end/2+k-1);
        xp0(end) = sum(xp_sol(end/2+k-1:end));
    end
    [~, stat_boot,exit]=stat_test_n_indep_theta(db_boot,vect_K_boot, xp0);
    if exit>0
        vect_stat_boot=[vect_stat_boot;stat_boot];
    end
end


res = mean(vect_stat_boot>=val_stat);