% Bootstrap test of no selection.

function res= test_selection_boot(data, b1_int_st, b2_int_st, b1_int_mov, grille,nb_boot)

options = optimset('Display','off','MaxFunEvals',1e6,'MaxIter',100000);
res = zeros(nb_boot,1);

N = size(data,1);

n_gr = length(grille);
% Diff computes F_{y1|P=1} o F_{y1|P=3}^{-1} o F_{y2|P=3} - F_{y2|P=2}
Diff =  zeros(n_gr,1);

for j=1:nb_boot
    sample_boot = datasample(data,N);

    % Interviewers there in (2001 or 2002) and 2003
    stayers = sample_boot((sample_boot(:,2)>0 & sample_boot(:,4)>0),:);
    % Interviewers there only in 2001 or 2002
    movers01 = sample_boot((sample_boot(:,2)>0 & sample_boot(:,4)==0),1:2);
    % Interviewers there only in 2003
    movers03 = sample_boot((sample_boot(:,2)==0 & sample_boot(:,4)>0),3:4);

    n1_st = stayers(:,2);
%     k1_st = stayers(:,1);
    n2_st = stayers(:,4);
%     k2_st = stayers(:,3);

    n1_mov = movers01(:,2);
    n2_mov = movers03(:,2);

    N_st1 = length(n1_st);
    unif_st1 = rand(N_st1,1);
    y1_st = zeros(N_st1,1);
    
    for k=1:N_st1
        p =  [b1_int_st(1:end-1)' -unif_st1(k)];
        rac=roots(p);
        y1_st(k) =sum(rac.* (imag(rac)==0) .* (rac<=1.0001) .* (rac>=-0.0001));
        y1_st(k)=min(max(y1_st(k),0),1);
    end

    k1_st = binornd(n1_st,y1_st);    
    
    N_st2 = length(n2_st);
    unif_st2 = rand(N_st2,1);
    y2_st = zeros(N_st1,1);
    
    for k=1:N_st2
        p =  [b2_int_st(1:end-1)' -unif_st2(k)];
        rac=roots(p);        
        y2_st(k) =sum(rac.* (imag(rac)==0) .* (rac<=1.0001) .* (rac>=-0.0001));
        y2_st(k)=min(max(y2_st(k),0),1);
    end

    k2_st = binornd(n2_st,y2_st);    

    N_mov1 = size(movers01,1);

    unif_mov1 = rand(N_mov1,1);
    y1_mov = zeros(N_mov1,1);

    for k=1:N_mov1
        p =  [b1_int_mov(1:end-1)' -unif_mov1(k)];
        rac=roots(p);
        y1_mov(k) =sum(rac.* (imag(rac)==0) .* (rac<=1.0001) .* (rac>=-0.0001));
        y1_mov(k)=min(max(y1_mov(k),0),1);
    end
    
    k1_mov = binornd(n1_mov,y1_mov);

    N_mov2 = size(movers03,1);
    unif_mov2=rand(N_mov2,1);
    y2_mov = zeros(N_mov2,1);

    for k=1:N_mov2
        p1 = [b1_int_mov(1:end-1)' -unif_mov2(k)];
        rac1=roots(p1);
        q = sum(rac1.* (imag(rac1)==0) .* (rac1<=1.0001) .* (rac1>=-0.0001));
        q = min(max(q,0),1);
        H_U = polyval(b1_int_st, q);
        p =  [b2_int_st(1:end-1)' -H_U];
        rac=roots(p);
        y2_mov(k) = sum(rac.* (imag(rac)==0) .* (rac<=1.0001) .* (rac>=-0.0001));
        y2_mov(k)=min(max(y2_mov(k),0),1);
    end

    k2_mov = binornd(n2_mov,y2_mov);

    % Bootstrapped version of Delta
    % We first compute the sieve ML estimator of F_{Y|X=x,S=s} 
    
    a0 = sqrt(3)*[0;0;1;0];
    a1 = fmincon(@(a) log_vrais_binom(a, k1_st, n1_st), a0, [],[],[],[],[],[],@contrainte_densite,options);

    b1 = conv(a1,a1);
    b1_int_st_boot =  polyint(b1')';

    a2 = fmincon(@(a) log_vrais_binom(a, k2_st, n2_st), a0, [],[],[],[],[],[],@contrainte_densite,options);

    b2 = conv(a2,a2);
    b2_int_st_boot =  polyint(b2')';

    a0 = sqrt(3)*[0;1;0];
    a1 = fmincon(@(a) log_vrais_binom(a, k1_mov, n1_mov), a0, [],[],[],[],[],[],@contrainte_densite,options);
    b1 = conv(a1,a1);
    b1_int_mov_boot =  polyint(b1')';

    a2 = fmincon(@(a) log_vrais_binom(a, k2_mov, n2_mov), a0, [],[],[],[],[],[],@contrainte_densite,options);
    b2 = conv(a2,a2);
    b2_int_mov =  polyint(b2')';

    for b=1:n_gr
        gr_b = grille(b);
        p=  [b1_int_st_boot(1:end-1)', -polyval(b2_int_st_boot, gr_b)];
        rac=roots(p);
        qq_st =sum(rac.* (imag(rac)==0) .* (rac<=1.0001) .* (rac>=-0.0001));
        qq_st = min(max(qq_st,0),1);
        Diff(b) = polyval(b1_int_mov_boot,qq_st) -  polyval(b2_int_mov,gr_b);
    end
    res(j) = max(abs(Diff));

end

end

