% Construction of the inverse of the variance of the moment conditions 
% E[1{N=n}(1{R=r} - p_{r,n})|X,S]=0, for a given vector a. When a is a
% consistent estimator, this yields an estimator of the optimal weighting 
% matrix.

function W = weighting_matrix_GMM_test_specif_MLE(n,r,a)

[~,~,~,labels]=crosstab(n,r);
temp=str2double(labels);
vect_n = temp(~isnan(temp(:,1)),1)';

b=conv(a,a);
% degree of the polynomial corresponding to F_y
K_L = length(b)-1;
W=[];
for i=vect_n
    p_i=zeros(i,1);
    for j=1:i
        p_i(j) = nchoosek(i,j)*(beta(j+(0:K_L)+1,i-j+1) * flipud(b));
    end
    mat=mean(n==i)*(diag(p_i)-p_i*p_i');
    W=blkdiag(W,inv(mat));
end
