% Function computing the probability y chosen by an interviewer facing a 
% contract t,n which is a vector of size n+1.

function res= y_theta_t(vect_theta,t,n,alpha,beta, borne_inf_y, borne_sup_y, indic_Cprime)

%vect_theta must be sorted (by increasing order) because we are using here
% theta -> y(theta) decreasing.

m = length(vect_theta);
res = zeros(1,m);

milieu = floor((m+1)/2);

theta_m = vect_theta(milieu);

lgr= borne_sup_y - borne_inf_y;

if lgr > 0.1
    grille_y=(borne_inf_y:lgr/10:borne_sup_y-lgr/10);
    diff = t' * vect_p_prime(grille_y,n) - theta_m * alpha * C_prime(grille_y, beta, indic_Cprime);
    borne_inf2 = max(grille_y(diff>0));
    if isempty(borne_inf2)
        borne_inf2  = borne_inf_y;
    end
    borne_sup2 = borne_inf2 + lgr/10;
else
    borne_inf2=borne_inf_y;
    borne_sup2=borne_sup_y;
end

res(milieu) = fminbnd(@(y) pr_resoud_y(y,theta_m,t,n,alpha,beta,indic_Cprime),borne_inf2,borne_sup2);

if milieu > 1
    res(1:milieu-1) = y_theta_t(vect_theta(1:milieu-1),t,n,alpha,beta, res(milieu), borne_sup_y,indic_Cprime);
end
if milieu < m
    res(milieu+1:end) = y_theta_t(vect_theta(milieu+1:end),t,n,alpha,beta, borne_inf_y, res(milieu),indic_Cprime);
end    

end


function res= pr_resoud_y(y,theta,t,n,alpha,beta,indic_Cprime)

res = (vect_p_prime(y,n)' * t - theta * alpha * C_prime(y, beta, indic_Cprime)).^2;

end