* Change the path!
use "/Users/xdhaulfoeuille/Documents/Recherche/Papiers finis/Selection adverse empirique/Donnees et programmes/data.dta", clear

* Table 1
preserve
collapse y (count) nb=y, by(ident year)
bysort year: su y nb 

* Figure 1, left panel
count if year==2001
scalar Nb01=r(N)
count if year==2002
scalar Nb02=r(N)
sort y
g cdf1=0
g cdf2=0
replace cdf1=cdf1[_n-1]+(year==2001)/Nb01 if _n>1
replace cdf2=cdf2[_n-1]+(year==2002)/Nb02 if _n>1
twoway line cdf1 cdf2 y, sort legend(label(1 "2001") label(2 "2002")) xtitle("")
restore

* Figure 1, right panel
g year01 = (year == 2001)
g year02 = (year == 2002)
g year03 = (year == 2003)

preserve 
collapse y, by(ident year03)
count if year03==0
scalar Nb01_02=r(N)
count if year03==1
scalar Nb03=r(N)

sort y
g cdf1=0
g cdf2=0
replace cdf1=cdf1[_n-1]+(year03==0)/Nb01_02 if _n>1
replace cdf2=cdf2[_n-1]+(year03==1)/Nb03 if _n>1
twoway line cdf1 cdf2 y, sort legend(label(1 "2001-2002") label(2 "2003")) xtitle("")
restore

* Table 2
* Subsequently we focus on families
keep if family==1

g basic = 4.7 - (0.1)*year03
g bonus = (20.3 - (0.1)*year02+2.6*year03)*y
g total= basic+bonus
preserve
collapse y (count) nb=y (sum) basic (sum) bonus (sum) total, by(ident year)
bysort year: su y nb basic bonus total
restore

* Table 3
bysort year ident: egen nb = count(_n)

* Different functional forms on n
gen nb2 = nb*nb
g nb11_20 = (nb-10)*(nb>10)
g nb21 = (nb-20)*(nb>20)


bysort ident: egen id1 = max(year01) 
bysort ident: egen id2 = max(year02) 
bysort ident: egen id3 = max(year03)

gen stayer = (max(id1,id2)==1 & id3==1) 
gen partic = (max(id1,id2)==1 & id3==0) + 2* (max(id1,id2)==0 & id3==1) + 3*(max(id1,id2)==1 & id3==1)

* Interviewer table to compute E(r/n|n) 
preserve
collapse (mean) y nb nb2 nb11_20 nb21, by (ident year partic) 
reg y nb i.year#i.partic, cluster(ident)
reg y nb nb2 i.year#i.partic, cluster(ident)
test nb=nb2=0
reg y nb nb11_20 nb21 i.year#i.partic, cluster(ident)
test nb=nb11_20=nb21=0
restore

* Table 4: independence test (theta indep. of X for stayers)
g exp10 = (exp>10)
g coll_house = (housing_type=="C") if housing_type~="P"
gen nb_r = real(nb_rooms) if ~inlist(nb_rooms,"N","O")

* First column
preserve
collapse rural small_urban large_urban coll_house nb_r exp10 if stayer==1, by(ident year03)
ksmirnov coll_house, by(year03)
ksmirnov nb_r, by(year03)
ksmirnov rural, by(year03)
ksmirnov small_urban, by(year03)
ksmirnov large_urban, by(year03)

* Second column
ksmirnov coll_house if exp10==1, by(year03)
ksmirnov nb_r if exp10==1, by(year03)
ksmirnov rural if exp10==1, by(year03)
ksmirnov small_urban if exp10==1, by(year03)
ksmirnov large_urban if exp10==1, by(year03)
restore


* Table 5
gen exp_new = log(exp+ year02 + 2*year03)
gen exp3 = (exp + year02 + 2*year03>=3)
gen exp5 = (exp + year02 + 2*year03>=5)

clogit y year03, group(ident) 
clogit y exp_new year03, group(ident) 
clogit y exp3 year03, group(ident) 
clogit y exp5 year03, group(ident) 

